import greenfoot.*;

public class Explosion extends Actor {
    int speed, trans = 255;
    double posx, posy;
    boolean init;

    public void act() {
        if (!init) {
            init = true;
            turnTowards(384, 512);
            setRotation(getRotation() + Greenfoot.getRandomNumber(91) - 45);
            posx = getX();
            posy = getY();
        }
        better(speed);
        trans -= 4;
        if (trans <= 0) {
            getWorld().removeObject(this);
            return;
        }
        getImage().setTransparency(trans);
    }    

    public Explosion() {
        speed = Greenfoot.getRandomNumber(8);
        GreenfootImage img = getImage();
        img.setColor(new Color(255, 255, 255, 63));
        img.fillOval(16, 16, img.getWidth() - 32, img.getHeight() - 32);
    }
    
    public void better(double distance) {
        double radians = Math.toRadians(getRotation());
        double dx = Math.cos(radians) * distance;
        double dy = Math.sin(radians) * distance;
        posx += dx;
        posy += dy;
        setLocation((int)posx, (int)posy);
    }
}
