import greenfoot.*;

public class Mover extends Entity {
    protected double posx, posy, velx, vely, damage = 1;
    boolean touched;
    protected int jumps, limit, strength, weapon, ammo;

    public boolean update() {
        if (posx < -64 || posy < -64 || posx > 832 || posy > 576) {
            for (int i = 0; i < 32; i++) {
                getWorld().addObject(new Explosion(), (int)posx, (int)posy);
            }
            return false;
        }
        Mover mover = (Mover)getOneIntersectingObject(Mover.class);
        if (mover != null) {
            double actual = Math.log(damage) / 8;
            velx = actual * (posx - mover.posx);
            vely = actual * (posy - mover.posy);
            if (!touched) {
                damage++;
                touched = true;
            }
        } else {
            touched = false;
        }
        Platform platform = (Platform)getOneIntersectingObject(Platform.class);
        if (platform != null) {
            int y = platform.posy;
            int h = platform.getImage().getHeight();
            if (vely > 0) {
                jumps = 0;
                posy = y - h / 2 - getImage().getHeight() / 2 + 1;
                vely = 0;
            } else if (vely <= 0 && posy > y) {
                posy = y + h / 2 + getImage().getHeight() / 2;
                vely = 0;
            }
        }
        posx += velx;
        posy += vely;
        velx *= 0.875;
        vely += 0.5;
        if (ammo == 0) {
            weapon = 0;
        }
        Item item = (Item)getOneIntersectingObject(Item.class);
        if (item != null) {
            weapon = 1;
            ammo = 25;
            item.destroy();
        }
        return true;
    }

    public void shoot(int tx, int ty) {
        getWorld().addObject(new Bullet(posx, posy, tx, ty), getX(), getY());
        ammo--;
    }

    public void go() {
        MyWorld w = (MyWorld)getWorld();
        setLocation((int)posx + w.xOff(), (int)posy + w.yOff());
    }

    public void jump() {
        jumps++;
        vely = jumps > limit ? vely : -strength;
    }
}
