import greenfoot.*;

public class MyWorld extends World {
    int level = 1;
    double posx = 384, posy = 256, velx, vely;

    public MyWorld() {    
        super(768, 512, 1, false);
        addObject(new Layer(1), 384, 256);
        addObject(new Layer(2), 384, 256);
        addObject(new Layer(3), 384, 256);
        addObject(new Platform(480, 16), 384, 384);
        addObject(new Platform(120, 8), 256, 256);
        addObject(new Platform(120, 8), 512, 256);
        addObject(new Player(), 384, 256);
        addObject(new Display(), 384, 512 - 64);
        getBackground().setColor(Color.BLACK);
        getBackground().fill();
    }

    public void act() {
        Player player = (Player)getObjects(Player.class).get(0);
        posx += velx;
        posy += vely;
        velx -= (player.getX() - 384) / 64;
        vely -= (player.getY() - 256) / 64;
        velx *= 0.5;
        vely *= 0.5;
        for (Entity e : getObjects(Entity.class)) {
            e.go();
        }
        for (Entity e : getObjects(Entity.class)) {
            e.no();
        }
        if (getObjects(Js.class).isEmpty()) {
            for (int i = 0; i < level; i++) {
                addObject(new Js(), -100, -100);
            }
            level++;
            getObjects(Player.class).get(0).lives += 2;
        }
    }

    public int xOff() {
        return (int)posx - 384;
    }

    public int yOff() {
        return (int)posy - 256;
    }
}
